package code;

public class Displacement extends Address {

	private String offset;
	private Address base;
	
	public Address base() { return base; }
	public String offset() { return offset; }
	
	public Displacement( String offset, Address base ) {
		this.offset = offset;
		this.base = base;
		}
	
	public Displacement( long offset, Address base ) {
		if ( offset == 0 )
			this.offset = "0";
		else if ( offset < 0 )
			this.offset = "-0x" + Long.toHexString( - offset );
		else
			this.offset = "0x" + Long.toHexString( offset );
		this.base = base;
		}
	
	public Displacement plus( String offset ) {
		return new Displacement( this.offset + "+" + offset, base );
		}
	
	public Displacement plus( long offset ) {
		return new Displacement( this.offset + "+0x" + Long.toHexString( offset ), base );
		}
	
	public String toString() {
		return offset + "(" + base + ")";
		}
	
	}
