package env;

import type.*;

public class Offset {

	private static int roundup( int value, int align ) {
		return ( value + align - 1 ) / align * align;
		}
		
	private int interp = 0;
	private int compile = 0;
	public int interp() { return interp; }
	public int compile() { return compile; }

	public Offset( int interp, int compile ) {
		this.interp = interp;
		this.compile = compile;
		}

	public Offset() {
		this( 0, 0 );
		}

	public void set( int interp, int compile ) { 
		this.interp = interp; 
		this.compile = compile; 
		}
	
	public void set( Offset offset ) { 
		this.interp = offset.interp; 
		this.compile = offset.compile; 
		}
	
	public Offset copy() {
		return new Offset( interp, compile );
		}
		
	public Offset inc( Offset size ) {
		Offset value = copy();
		this.interp += size.interp(); 
		this.compile += roundup( size.compile(), Type.WORD );
		return value;
		}
		
	public void align() {
		compile = roundup( compile, Type.WORD );
		}
		
	public String toString() {
		return "( " + Integer.toHexString( interp ) + ", " 
			+ Integer.toHexString( compile ) + " )";
		}
	}
