package node;
import env.*;
import runEnv.*;
import text.*;
import java.util.*;

public class DeclStmtListNode extends ListNode< DeclStmtNode > {

	private int section;
	public int section() { return section; }

	public DeclStmtListNode() {
		super( "%n" );
		}
	
	public DeclStmtListNode( DeclStmtNode node ) {
		this();
		addElement( node );
		}
		
	public void genEnv( int section, Env env ) {
		super.genEnv( env );
		this.section = section;
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = null;
			try {
				declStmt = elementAt( i );
				declStmt.genEnv( section, env );
				}
			catch ( Error exception ) {
				Print.error().println( "Error: " + exception.getMessage() 
					+ " at%+%n" + declStmt + "%-" );
				setElementAt( i, new ErrorDeclStmtNode() );
				}
			}
		}

	public void setType() {
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = null;
			try {
				declStmt = elementAt( i );
				declStmt.setType();
				}
			catch ( Error exception ) {
				Print.error().println( "Error: " + exception.getMessage() 
					+ " at%+%n" + declStmt + "%-" );
				setElementAt( i, new ErrorDeclStmtNode() );
				}
			}
		}

	public void checkType() {
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = null;
			try {
				declStmt = elementAt( i );
				declStmt.checkType();
				}
			catch ( Error exception ) {
				Print.error().println( "Error: " + exception.getMessage() 
					+ " at%+%n" + declStmt + "%-" );
				setElementAt( i, new ErrorDeclStmtNode() );
				}
			}
		}

	public void genOffset() {
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = elementAt( i );
			declStmt.genOffset();
			}
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = elementAt( i );
			declStmt.eval( runEnv );
			}
		}

	public void genCode() {
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = elementAt( i );
			declStmt.genCode();
			}
		}

	}

