package node.declNode;
import node.*;
import node.typeNode.*;
import node.declNode.declaratorNode.*;
import env.*;
import type.*;
import runEnv.*;
import code.*;

public class VarDeclNode extends DeclStmtNode {

	private TypeNode typeNode;
	private DeclaratorListNode declrList;

	public VarDeclNode( TypeNode typeNode, DeclaratorListNode declrList ) {
		this.typeNode = typeNode;
		this.declrList = declrList;
		}

	public String toString() {
		return typeNode + " " + declrList + ";";
		}

	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		typeNode.genEnv( env );
		declrList.genEnv( section, env );
		}

	public void setType() {
		Type type = typeNode.getType();
		declrList.setType( type );
		}

	public void checkType() {
		declrList.checkType();
		}

	public void genOffset() {
		declrList.genOffset();
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		declrList.eval( runEnv );
		}

	public void genCode() {
		Code.enter();
		declrList.genCode();
		Code.exit();
		}

	}
