package node.declNode.declaratorNode;
import node.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;
import text.*;

public class UninitDeclaratorNode extends DeclaratorNode {

	public UninitDeclaratorNode( String ident ) {
		super( ident );
		}

	public String toString() {
		return ident;
		}

	public void checkType() {
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		switch ( decl.env().envKind() ) {
			case Env.ENV_GLOBAL:
			case Env.ENV_METHOD:
			case Env.ENV_CLASS:
				PtrValue address = runEnv.elementAt( decl );
				decl.type().initAddress( runEnv, address );
				break;
			default:
				throw new Error( 
					"Invalid environment of " 
					+ Env.envKindText( decl.env().envKind() )
					+ " for identifier " + decl.ident() );
			}
		}

	public void genCode() {
		switch ( decl.env().envKind() ) {
			case Env.ENV_GLOBAL:
			case Env.ENV_METHOD:
			case Env.ENV_CLASS:
				setAddress( decl.address() );
				Displacement varAddress = loadAddress( new Usage( env() ) );
				Code.loadA( SpecialReg.newInstPtr, varAddress );
				decl.type().initAddressCode();
				break;
			default:
				throw new Error( 
					"Invalid environment of " 
					+ Env.envKindText( decl.env().envKind() )
					+ " for identifier " + decl.ident() );
			}
		}
	}
