package node.exprNode.binaryNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public abstract class BinaryNode extends ExprNode {

	protected String operator;
	protected String opCode;
	protected Type operandType;
	protected ExprNode left, right;

	public BinaryNode( ExprNode left, ExprNode right ) {
		this.left = left;
		this.right = right;
		}
		
	public String toString() {
		return 
			left.toString( precedence ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		left.genEnv( env );
		right.genEnv( env );
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		left.evalCode( sibling );
		right.evalCode( left );
		left.loadReg( usage().plus( right.address() ) );
		right.loadReg( usage().plus( left.address() ) );
		setAddress( obtainReg( type, usage() ) );
		}
	}
