package node.exprNode.binaryNode.boolNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class OrNode extends BoolNode {

	public OrNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_OR;
		operator = "||";
		opCode = "or";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new BoolValue( leftValue.boolValue() || rightValue.boolValue() );
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Code.instrn( opCode, left.address(), right.address(), address() );
		}

	public void boolCode( 
		Node sibling, 
		Relative trueLabel, 
		Relative falseLabel, 
		boolean flowIntoTrue ) {
		setSibling( sibling );
		Relative secondPart = Label.newLabel();
		Code.enter();
		left.boolCode( sibling, trueLabel, secondPart, false );
		Code.labelDefn( secondPart );
		right.boolCode( sibling, trueLabel, falseLabel, flowIntoTrue );
		Code.exit();
		}

	}
