package node.exprNode.castNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class CastToVoidNode extends ExprNode {

	private ExprNode expr;
	private Type exprType;
	
	public CastToVoidNode( ExprNode expr ) {
		precedence = PREC_CAST;
		this.expr = expr;
		}
	
	public String toString() {
		return "( void )" + expr;
		}

	public Type checkType() {
		exprType = expr.type();
		return VoidType.type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue exprValue = expr.eval( runEnv );
		return VoidValue.value;
		}
	
	public void evalCode( Node sibling ) {
		setSibling( sibling );
		expr.evalCode( sibling );
		setAddress( null );
		}
	
	}

