package node.exprNode.castNode;
import node.*;
import node.declNode.*;
import node.typeNode.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;
import text.*;

public class ExplicitCastNode extends ExprNode {

	private TypeNode typeNode;
	private Type exprType;
	private ExprNode right;

	public ExplicitCastNode( TypeNode typeNode, ExprNode right ) {
		this.typeNode = typeNode;
		this.right = right;
		precedence = PREC_CAST;
		}

	public String toString() {
		return "( " + typeNode + " ) " + right.toString( precedence );
		}
		
	public void genEnv( Env env ) {
		super.genEnv( env );
		typeNode.genEnv( env );
		right.genEnv( env );
		}

	public Type checkType() {
		type = typeNode.getType();
		exprType = right.checkType();
		right = right.castTo( Type.CAST_EXPLICIT, type );
		return type;
		}
	
	public RunValue eval( RunEnv runEnv ) {
		return right.eval( runEnv );
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		right.evalCode( sibling );
		right.loadReg( usage() );
		setAddress( right.address() );
		}
	}
