package node.exprNode.postfixNode;
import node.*;
import node.exprNode.*;
import node.exprNode.variableNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public abstract class PostfixVarNode extends ExprNode {

	protected VariableNode left;
	protected String operator;
	protected Type operandType;
	protected String opCode;

	public PostfixVarNode( VariableNode left ) {
		this.left = left;
		precedence = PREC_POSTFIX;
		}
		
	public String toString() {
		return  left + " " + operator;
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		left.genEnv( env );
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		left.evalAddrCode( sibling );
		}

	}
