package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import node.exprNode.variableNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;
import text.*;

public class AddressNode extends PrefixVarNode {

	public AddressNode( VariableNode right ) {
		super( right );
		operator = "&";
		}

	public Type checkType() {
		Type rightType = right.checkType();
		if ( ! right.addressable() )
			throw new Error( "Operand for & not addressable" );
		type = new PtrType( rightType );
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return right.evalAddr( runEnv );
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Register register = obtainReg( type, usage() );
		Address address = right.loadAddress( usage() );
		Code.loadA( register, address );
		setAddress( register );
		}

	}
