package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class NotNode extends PrefixNode {

	public NotNode( ExprNode right ) {
		super( right );
		operator = "!";
		}

	public Type checkType() {
		Type rightType = right.checkType();
		operandType = BoolType.type;
		type = BoolType.type;
		right = right.castTo( Type.CAST_IMPLICIT, type );
		opCode = "xor";
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		return new BoolValue( ! rightValue.boolValue() );
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Code.instrn( "xor", right.address(), new Literal( 1 ), address() );
		}
		
	public void boolCode( 
		Node sibling, 
		Relative trueLabel, 
		Relative falseLabel, 
		boolean flowIntoTrue ) {
		setSibling( sibling );
		right.boolCode( sibling, falseLabel, trueLabel, ! flowIntoTrue );
		}

	}
