package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public abstract class PrefixNode extends ExprNode {

	protected ExprNode right;
	protected String operator;
	protected Type operandType;
	protected String opCode;

	public PrefixNode( ExprNode right ) {
		this.right = right;
		precedence = PREC_PREFIX;
		}
		
	public String toString() {
		return operator + " " + right.toString( precedence );
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		right.genEnv( env );
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		right.evalCode( sibling );
		right.loadReg( usage() );
		setAddress( obtainReg( type, usage() ) );
		}
	}
