package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public class IndirectVariableNode extends VariableNode {

	private ExprNode address;
	
	public IndirectVariableNode( ExprNode address ) {
		this.address = address;
		}

	public String toString() {
		return address.toString( ExprNode.PREC_PRIMARY ) + "^";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		address.genEnv( env );
		}

	public Type checkType() {
		Type pType = address.checkType();
		if ( ! ( pType instanceof PtrType ) )
			throw new Error( "Attempting to dereference a non pointer type " + pType );
		PtrType ptrType = ( PtrType ) pType;
		type = ptrType.subType();
		return type;
		}

	public PtrValue evalAddr( RunEnv runEnv ) {
		RunValue value = address.eval( runEnv );
		return value.addressValue();
		}

	public void evalAddrCode( Node sibling ) {
		setSibling( sibling );
		address.evalCode( sibling );
		Register base = address.loadReg( usage() );
		setAddress( new Indirect( base ) );
		}
	}
