package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public class ExprStmtNode extends StmtNode {

	private ExprNode expr;
	
	public ExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return expr + ";";
		}
		
	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		expr.genEnv( env );
		}

	public void checkType() {
		Type type = expr.checkType();
		expr = expr.castTo( Type.CAST_IMPLICIT, VoidType.type );
		}

	public void eval( RunEnv runEnv ) {
		expr.eval( runEnv );
		}

	public void genCode() {
		Code.enter();
		expr.evalCode( null );
		Code.exit();
		}
	}
