package type;

import env.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public  class ClassType extends Type {

	private String ident;
	private Env env;

	public String ident() { return ident; }
	public Env env() { return env; }

	public ClassType( String ident, Env env ) {
		this.ident = ident;
		this.env = env;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof ClassType ) )
			return false;
		ClassType classType = ( ClassType ) type;
		return classType.ident().equals( ident );
		}

	public boolean isCastable( int castKind, Type type ) {
		return false;
		}

	public String toString() {
		return "class " + ident;
		}

	public Type instanceType() {
		return new ClassInstanceType( ident, env );
		}

	public Offset size() {
		return new Offset( 0, 0 );
		}
		
	public void initAddress( RunEnv runEnv, PtrValue address ) {
		}

	public void initAddressCode( Displacement address ) {
		}
	}
