package type.basicType;

import type.*;
import env.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public  class VoidType extends BasicType {

	public final static VoidType type = new VoidType();

	public VoidType() {
		}

	public boolean equals( Type type ) {
		return type instanceof VoidType;
		}

	public boolean isCastable( int castKind, Type type ) {
		return true;
		}

	public String toString() {
		return "void";
		}
		
	public Offset size() {
		return new Offset( 0, 0 );
		}
		
	public void initAddress( RunEnv runEnv, PtrValue address ) {
		address.setValue( VoidValue.defaultValue );
		}

	public void initAddressCode( Displacement address ) {
		}
	}
