package node.exprNode;

import runEnv.*;

public class IfNode extends ExprNode {

	private ExprNode cond;
	private ExprNode expr1;
	private ExprNode expr2;

	public IfNode( ExprNode cond, ExprNode expr1, ExprNode expr2 ) {
		this.cond = cond;
		this.expr1 = expr1;
		this.expr2 = expr2;
		precedence = 7;
		}

	public String toString() {
		return "if " + cond + " then " + expr1 + " else " + expr2 + " fi";
		}

	public Object eval( RunEnv runEnv ) {
		boolean condValue = Cast.booleanValue( cond.eval( runEnv ) );
		if ( condValue )
			return expr1.eval( runEnv );
		else
			return expr2.eval( runEnv );
		}
		
	}
