package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class FunctionDeclNode extends StmtNode {

	private String ident;
	private FormalParamListNode formalParams;
	private ExprNode expr;
	
	public String ident() { return ident; }
	public FormalParamListNode formalParams() { return formalParams; }
	public ExprNode expr() { return expr; }

	public FunctionDeclNode( 
		String ident, 
		FormalParamListNode formalParams, 
		ExprNode expr ) {
		this.ident = ident;
		this.formalParams = formalParams;
		this.expr = expr;
		}
	
	public String toString() {
		return ident + "( " + formalParams + " ) = " + expr + ";";
		}
		
	public void eval( RunEnv runEnv ) {
		runEnv.locals().put( ident, new FunctionValue( formalParams, expr, runEnv ) );
		}
		
	}
