package node.exprNode.binaryNode.arithNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class PlusNode extends ArithNode {

	public PlusNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_ADD;
		operator = "+";
		}

	public Object eval( RunEnv runEnv ) {
		Object leftObject = left.eval( runEnv );
		Object rightObject = right.eval( runEnv );
		if ( leftObject instanceof String || rightObject instanceof String )
			return leftObject.toString() + rightObject.toString();
		else {
			int leftValue = Cast.intValue( leftObject );
			int rightValue = Cast.intValue( rightObject );
			return new Integer( leftValue + rightValue );
			}
		}
		
	}
