package node.exprNode.valueNode;
import java.util.*;
import runEnv.*;
import node.stmtNode.*;
import node.exprNode.*;
import node.declNode.*;
import node.declNode.declaratorNode.*;

public class FunctionValueNode extends ValueNode {

	private IdentListNode formalParams;
	private DeclNode locals;
	private StmtListNode body;
	
	public IdentListNode formalParams() { return formalParams; }
	public DeclNode locals() { return locals; }
	public StmtListNode body() { return body; }

	public FunctionValueNode( 
		IdentListNode formalParams, 
		DeclNode locals, 
		StmtListNode body ) {
		this.formalParams = formalParams;
		this.locals = locals;
		this.body = body;
		}
	
	public String toString() {
		return "funct" + "( " + formalParams + " )%+" 
			+ locals + "%nbegin%+%n" + body + "%-%nend%-";
		}
		
	public Object eval( RunEnv runEnv ) {
		return new FunctionValue( this, runEnv );
		}
		
	}
