package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class ForStmtNode extends StmtNode {

	private ExprNode initial;
	private ExprNode cond;
	private ExprNode increment;
	private StmtListNode stmtList;

	public ForStmtNode( 
		ExprNode initial, 
		ExprNode cond, 
		ExprNode increment, 
		StmtListNode stmtList ) {
		this.initial = initial;
		this.cond = cond;
		this.increment = increment;
		this.stmtList = stmtList;
		}

	public String toString() {
		return "for " + initial + "; " + cond + "; " + increment + " do%+%n" 
			+ stmtList + "%-%nend";
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		for ( 
			initial.eval( runEnv ); 
			Cast.booleanValue( cond.eval( runEnv ) ); 
			increment.eval( runEnv ) )
			stmtList.eval( runEnv );
		}
		
	}
