package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class IfStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtListNode thenPart;
	private ElseOptNode elsePart;

	public IfStmtNode( ExprNode cond, StmtListNode thenPart, ElseOptNode elsePart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elsePart = elsePart;
		}

	public String toString() {
		return "if " + cond + " then%+%n" + thenPart + "%-" + elsePart + "%nend";
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		if ( Cast.booleanValue( cond.eval( runEnv ) ) )
			thenPart.eval( runEnv );
		else
			elsePart.eval( runEnv );
		}
		
	}
