package env;

import type.*;

import java.util.*;

public class DeclList {

	private Vector< Decl > decls = new Vector< Decl >();
	
	public DeclList() {
		}
	
	public int size() {
		return decls.size();
		}

	public Decl elementAt( int i ) {
		return ( Decl ) decls.elementAt( i );
		}

	public Decl declare( String ident, int kind, Type type ) {
		if ( search( ident ) != null )
			return null;
		Decl decl = new Decl( ident, kind, type );
		decls.addElement( decl );
		return decl;
		}

	public void setLevel( int level ) {
		for ( int i = 0; i < decls.size(); i++ )
			elementAt( i ).setLevel( level );
		}

	public int setOffset( int base ) {
		for ( int i = 0; i < decls.size(); i++ )
			elementAt( i ).setOffset( base + i );
		return base + decls.size();
		}

	public Decl search( String ident ) {
		for ( int i = 0; i < decls.size(); i++ )
			if ( elementAt( i ).ident().equals( ident ) )
				return elementAt( i );
		return null;
		}

	public String toString() {
		String result = "";
		for ( int i = 0; i < decls.size(); i++ )
			result += "%n" + elementAt( i );
		return result;
		}

	}
