package env;

import type.*;

public class Env {

	private int level;
	private Block block;
	private Env globals;
	
	public int level() { return level; }
	public Block block() { return block; }
	public Env globals() { return globals; }

	public Env( 
		Block block,
		Env globals ) {
		if ( globals == null )
			level = 0;
		else
			level = globals.level + 1;
		this.block = block;
		this.globals = globals;
		}
	
	public Type returnType() {
		Type returnType = block.returnType();
		if ( returnType != null )
			return returnType;
		if ( globals != null )
			return globals.returnType();
		return null;
		}

	public Decl search( String ident ) {
		Decl decl = block.search( ident );
		if ( decl != null )
			return decl;
		if ( globals != null )
			return globals.search( ident );
		return null;
		}

	public String toString() {
		if ( globals == null )
			return 
				"Env " + level + "%+%n"
				+ block +"%-%n";
		else
			return 
				"Env " + level + "%+%n"
				+ block +"%-%n"
				+ globals;
		}
	}
