package node.exprNode;
import env.*;
import type.*;
import runEnv.*;
import node.exprNode.variableNode.*;

public class VarExprNode extends ExprNode {

	private VariableNode variable;

	public VariableNode variable() { return variable; }

	public VarExprNode( VariableNode variable ) {
		this.variable = variable;
		precedence = PREC_PRIMARY;
		}

	public String toString() {
		return "" + variable;
		}

	public Type checkType( Env env ) {
		type = variable.checkType( env );
		return type;
		}
		
		
	public RunValue eval( RunEnv runEnv ) {
		return new RunValue( variable.eval( runEnv ) );
		}
	}
