package node.exprNode.binaryNode.relationNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class LessThanNode extends RelationNode {

	public LessThanNode( ExprNode left, ExprNode right ) {
		super( left, right );
		operator = "<";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		if ( operandType instanceof IntType )
			return new RunValue( leftValue.intValue() < rightValue.intValue() );
		else if ( operandType instanceof RealType )
			return new RunValue( leftValue.realValue() < rightValue.realValue() );
		error( "Invalid Type <=" );
		return null;
		}
	}
