package node.exprNode.prefixNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class NegateNode extends PrefixNode {

	public NegateNode( ExprNode right ) {
		super( right );
		operator = "-";
		}

	public Type checkType( Env env ) {
		Type rightType = right.checkType( env );
		if ( ! ( rightType instanceof IntType ) 
			&& ! ( rightType instanceof RealType ) )
			error( "Non arithmetic type for negation" );
		type = rightType;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		if ( type instanceof IntType )
			return new RunValue( - rightValue.intValue() );
		else if ( type instanceof RealType )
			return new RunValue( - rightValue.realValue() );
		error( "Invalid Type for -" );
		return null;
		}
	}
