package node.exprNode.primaryNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.typeNode.*;
import node.exprNode.*;

public class ArrayCreationNode extends PrimaryNode {

	private ExprNode sizeExpr;
	private TypeNode typeNode;

	public ArrayCreationNode( ExprNode sizeExpr, TypeNode typeNode ) {
		this.sizeExpr = sizeExpr;
		this.typeNode = typeNode;
		}

	public Type checkType( Env env ) {
		Type sizeExprType = sizeExpr.checkType( env );
		Type subType = typeNode.getType( env );
		sizeExpr = sizeExpr.castTo( IntType.type );
		type = new ArrayType( subType );
		return type;
		}

	public String toString() {
		return "new [ " + sizeExpr + " ]" + typeNode;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue size = sizeExpr.eval( runEnv );
		return new RunValue( new Multiple( size.intValue() ) );
		}
	}
