package node.exprNode.primaryNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;
import node.typeNode.*;

public class CreationNode extends PrimaryNode {

	private TypeNode typeNode;

	public CreationNode( TypeNode typeNode ) {
		this.typeNode = typeNode;
		}

	public Type checkType( Env env ) {
		type = typeNode.getType( env );
		return type;
		}

	public String toString() {
		return "new " + type;
		}

	public RunValue eval( RunEnv runEnv ) {
		if ( type instanceof IntType ) {
			return new RunValue( 0 );
			}
		else if ( type instanceof CharType ) {
			return new RunValue( '\0' );
			}
		else if ( type instanceof RealType ) {
			return new RunValue( 0.0 );
			}
		else if ( type instanceof BoolType ) {
			return new RunValue( false );
			}
		else if ( type instanceof StringType ) {
			return new RunValue( "" );
			}
		else if ( type instanceof ArrayType ) {
			return new RunValue( new Multiple( 0 ) );
			}
		else if ( type instanceof StructType ) {
			StructType structType = ( StructType ) type;
			int size = structType.fieldDecls().size();
			return new RunValue( new Multiple( size ) );
			}
		error( "Invalid Type for new" );
		return null;
		}
	}
