package node.exprNode.primaryNode;
import env.*;
import node.exprNode.*;
import type.*;
import runEnv.*;
import node.typeNode.*;

public class MultipleNode extends PrimaryNode {

	private TypeNode typeNode;
	private ExprListNode exprList;

	public MultipleNode( TypeNode typeNode, ExprListNode exprList ) {
		this.typeNode = typeNode;
		this.exprList = exprList;
		}

	public Type checkType( Env env ) {
		type = typeNode.getType( env );
		exprList.checkType( env );
		return type;
		}

	public ExprNode castTo( Type type ) {
		if ( type instanceof ArrayType )
			exprList.castArray( ( ArrayType ) type );
		else if ( type instanceof StructType )
			exprList.castMultiple( ( StructType ) type );
		else
			error( "Multiple must be an array or structure" );
		return this;
		}

	public String toString() {
		if ( exprList.size() == 0 )
			return "new " + typeNode + "{}";
		else
			return "new " + typeNode + "{ " + exprList + " }";
		}

	public RunValue eval( RunEnv runEnv ) {
		Multiple multiple = exprList.eval( runEnv );
		return new RunValue( multiple );
		}
	}
