package node.exprNode.variableNode;
import env.*;
import type.*;
import runEnv.*;

public class IdentVariableNode extends VariableNode {

	private String ident;
	private Decl decl;
	int level;
	
	public IdentVariableNode( String ident ) {
		this.ident = ident;
		}

	public Type checkType( Env env ) {
		level = env.level();
		decl = env.search( ident );
		if ( decl == null )
			error( "Undeclared Variable " + ident );
		if ( decl.kind() != Decl.VAR
			&& decl.kind() != Decl.VALUEPARAM
			&& decl.kind() != Decl.VARPARAM )
			error( "Identifier " + ident + " not declared as variable" );
		type = decl.type();
		return type;
		}

	public String toString() {
		return ident;
		}

	public RunData eval( RunEnv runEnv ) {
		//	Print.error().println( "Access " + ident );
		return runEnv.getData( level - decl.level(), decl.offset() );
		}
	}
