package node.stmtNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class ElseOpt2Node extends ElseOptNode {

	private ExprNode cond;
	private StmtListNode thenPart;
	private ElseOptNode elsePart;

	public ElseOpt2Node( 
		ExprNode cond,
		StmtListNode thenPart,
		ElseOptNode elsePart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elsePart = elsePart;
		}

	public String toString() {
		return "%nelif " + cond + " then%+%n" + thenPart + "%-" + elsePart;
		}

	public void checkType( Env env ) {
		Type condType = cond.checkType( env );
		cond = cond.castTo( BoolType.type );
		thenPart.checkType( env );
		elsePart.checkType( env );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		if ( cond.eval( runEnv ).boolValue() )
			thenPart.eval( runEnv );
		else
			elsePart.eval( runEnv );
		}

	}
