package node.stmtNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;
import text.*;

public class PrintStmtNode extends StmtNode {

	private ExprNode expr;
	
	public PrintStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "print( " + expr + " );";
		}
		
	public void checkType( Env env ) {
		Type exprType = expr.checkType( env );
		expr = expr.castTo( StringType.type );
		}

	public void eval( RunEnv runEnv ) {
		Print.interp().print( expr.eval( runEnv ) );
		}

	}
