package node.stmtNode;
import env.*;
import type.*;
import runEnv.*;
import node.exprNode.*;

public class ReturnExprStmtNode extends StmtNode {

	private ExprNode expr;

	public ReturnExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}

	public String toString() {
		return "return " + expr +";";
		}

	public void checkType( Env env ) {
		Type exprType = expr.checkType( env );
		Type returnType = env.returnType();
		if ( returnType == null )
			error( "Attempting to return when not inside function" );
		expr = expr.castTo( returnType );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		throw new ReturnException( expr.eval( runEnv ) );
		}

	}
