package node.stmtNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ReturnStmtNode extends StmtNode {

	public ReturnStmtNode() {
		}

	public String toString() {
		return "return;";
		}

	public void checkType( Env env ) {
		Type returnType = env.returnType();
		if ( returnType == null )
			error( "Attempting to return when not inside function" );
		if ( ! returnType.equals( VoidType.type ) )
			error( "Must return value for non void function" );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		throw new ReturnException( null );
		}

	}
