package node.stmtNode;
import env.*;
import type.*;
import runEnv.*;
import node.*;
import text.*;

public class StmtListNode extends ListNode< StmtNode > {

	public StmtListNode() {
		super( "%n" );
		}
	
	public StmtListNode( StmtNode node ) {
		this();
		addElement( node );
		}
		
	public void checkType( Env env ) {
		for ( int i = 0; i < size(); i++ ) {
			StmtNode stmt = elementAt( i );
			try {
				stmt.checkType( env );
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorStmtNode() );
				}
			}
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		for ( int i = 0; i < size(); i++ ) {
			StmtNode stmt = elementAt( i );
			stmt.eval( runEnv );
			}
		}
		
	}

