package node.stmtNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class WhileStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtListNode stmtList;

	public WhileStmtNode( ExprNode cond, StmtListNode stmtList ) {
		this.cond = cond;
		this.stmtList = stmtList;
		}

	public String toString() {
		return "while " + cond + " do%+%n" + stmtList + "%-%nend";
		}

	public void checkType( Env env ) {
		Type condType = cond.checkType( env );
		cond = cond.castTo( BoolType.type );
		stmtList.checkType( env );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		while ( cond.eval( runEnv ).boolValue() )
			stmtList.eval( runEnv );
		}

	}
