package type;

import env.*;

public  class FunctType extends Type {

	private Block block = new Block();
	
	public Block block() { return block; }
	public Type returnType() { return block.returnType(); }
	public DeclList formalDecls() { return block.formalDecls(); }

	public FunctType( Block block ) {
		this.block = block;
		}
	
	public boolean equals( Type type ) {
		if ( type == null )
			return false;
		type = type.nonRefType();
		if ( this == type )
			return true;
		if ( ! ( type instanceof FunctType ) )
			return false;
		FunctType otherType = ( FunctType ) type;
		if ( ! returnType().equals( otherType.returnType() ) )
			return false;
		DeclList formals = formalDecls();
		DeclList otherFormals = otherType.formalDecls();
		if ( formals.size() != otherFormals.size() )
			return false;
		for ( int i = 0; i < formals.size(); i++ ) {
			Decl decl1 = formals.elementAt( i );
			Decl decl2 = otherFormals.elementAt( i );
			if ( ! decl1.type().equals( decl2.type() ) )
				return false;
			}
		return true;
		}

	public String toString() {
		return "( " + formalDecls() + " )" + returnType();
		}
	}
