package type;

import env.*;

public  class StructType extends Type {

	private Block block;
	
	public DeclList fieldDecls() { return block.varDecls(); }

	public StructType( Block block ) {
		this.block = block;
		}
	
	public boolean equals( Type type ) {
		if ( type == null )
			return false;
		type = type.nonRefType();
		if ( this == type )
			return true;
		if ( ! ( type instanceof StructType ) )
			return false;
		StructType otherType = ( StructType ) type;
		DeclList fields = fieldDecls();
		DeclList otherFields = otherType.fieldDecls();
		if ( fields.size() != otherFields.size() )
			return false;
		for ( int i = 0; i < fields.size(); i++ ) {
			Decl decl1 = fields.elementAt( i );
			Decl decl2 = otherFields.elementAt( i );
			if ( ! decl1.ident().equals( decl2.ident() ) )
				return false;
			if ( ! decl1.type().equals( decl2.type() ) )
				return false;
			}
		return true;
		}

	public String toString() {
		return "struct(%+" + fieldDecls() + "%n%+)";
		}
	}
