package node;
import env.*;
import type.*;
import type.basicType.*;
import text.*;
import runEnv.*;

public class ProgramNode extends Node {

	private DeclStmtListNode globalLibrary;
	private DeclStmtListNode declStmtList;
	
	public ProgramNode( DeclStmtListNode globalLibrary, DeclStmtListNode declStmtList ) {
		this.globalLibrary = globalLibrary;
		this.declStmtList = declStmtList;
		}

	public String toString() {
		return declStmtList + "%n";
		}
		
	public void genEnv( Env env ) {
		super.genEnv( env );
		globalLibrary.genEnv( env );
		declStmtList.genEnv( env );
		}

	public void setType() {
		globalLibrary.setType();
		declStmtList.setType();
		}

	public void checkType() {
		try {
			globalLibrary.checkType();
			declStmtList.checkType();
			}
		catch ( Error exception ) {
			Print.error().println( exception.getMessage() );
			System.exit( -1 );
			}
		}

	public void eval( RunEnv runEnv ) throws UserException {
		globalLibrary.eval( runEnv );
		declStmtList.eval( runEnv );
		}

	}
