package node.declNode;
import env.*;
import type.*;
import runEnv.*;
import node.*;
import node.typeNode.*;
import text.*;

public class ClassDeclNode extends DeclStmtNode implements DeclNode {

	private String ident;
	private DeclStmtListNode fields;
	private Env localEnv;
	private Decl decl;

	public ClassDeclNode( String ident, DeclStmtListNode fields ) {
		this.ident = ident;
		this.fields = fields;
		}

	public String toString() {
		return "class " + ident + "(%+%n" + fields + "%n);%-";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		decl = env.declare( ident, Decl.SECT_CLASS, this );
		localEnv = new Env( Env.ENV_CLASS, env );
		decl.setType( new ClassType( ident, localEnv ) );
		fields.genEnv( localEnv );
		}

	public void setType() {
		fields.setType();
		}

	public void checkType() {
		}

	public void eval( RunEnv runEnv ) {
		}
	}
