package node.declNode;
import node.*;
import node.typeNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class MethodDeclNode extends DeclStmtNode implements DeclNode {

	private DeclStmtListNode formalParams;
	private DeclStmtListNode body;
	public DeclStmtListNode formalParams() { return formalParams; }
	public DeclStmtListNode body() { return body; }

	private Env localEnv;
	private Type returnType;
	private Decl decl;

	public Env localEnv() { return localEnv; }
	public Type returnType() { return returnType; }
	public Decl decl() { return decl; }

	private TypeNode returnTypeNode;
	private String ident;

	public MethodDeclNode( 
		TypeNode returnTypeNode,
		String ident,
		DeclStmtListNode formalParams,
		DeclStmtListNode body ) {
		this.formalParams = formalParams;
		this.body = body;
		this.returnTypeNode = returnTypeNode;
		this.ident = ident;
		}
	
	public String toString() {
		return returnTypeNode + " " + ident 
			+ "(%+%n" + formalParams() + " ) {%n" + body() + "%n}%-";
		}
		
	public void genEnv( Env env ) {
		super.genEnv( env );
		decl = env().declare( ident, Decl.SECT_METHOD, this );
		localEnv = new Env( Env.ENV_METHOD, env );
		localEnv().setDecl( decl );
		returnTypeNode.genEnv( env );
		formalParams.genEnv( localEnv );
		body.genEnv( localEnv );
		}

	public void setType() {
		returnType = returnTypeNode.getType();
		formalParams().setType();
		decl.setType( new MethodType( ident, returnType, localEnv().paramDecls() ) );
		body().setType();
		}

	public void checkType() {
		body.checkType();
		}

	public void eval( RunEnv runEnv ) {
		}

	}
