package node.declNode;
import node.*;
import node.typeNode.*;
import node.declNode.declaratorNode.*;
import env.*;
import type.*;
import runEnv.*;

public class VarParamDeclNode extends DeclStmtNode implements DeclNode {

	private TypeNode typeNode;
	private DeclaratorListNode declrList;

	public VarParamDeclNode( TypeNode typeNode, DeclaratorListNode declrList ) {
		this.typeNode = typeNode;
		this.declrList = declrList;
		}

	public String toString() {
		return "var " + typeNode + " " + declrList + ";";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		typeNode.genEnv( env );
		declrList.genEnv( Decl.SECT_VARPARAM, env );
		}

	public void setType() {
		Type type = typeNode.getType();
		declrList.setType( type );
		}

	public void checkType() {
		}

	public void eval( RunEnv runEnv ) {
		}

	}
