package node.declNode.declaratorNode;
import node.*;
import text.*;
import env.*;
import type.*;
import runEnv.*;
import java.util.*;

public class DeclaratorListNode extends ListNode< DeclaratorNode > {

	public DeclaratorListNode() {
		super( ", " );
		}
	
	public DeclaratorListNode( DeclaratorNode node ) {
		this();
		addElement( node );
		}
		
	public void genEnv( int section, Env env ) {
		super.genEnv( env );
		for ( int i = 0; i < size(); i++ ) {
			DeclaratorNode decltr = elementAt( i );
			decltr.genEnv( section, env );
			}
		}

	public void setType( Type type ) {
		for ( int i = 0; i < size(); i++ ) {
			try {
				DeclaratorNode decltr = elementAt( i );
				decltr.setType( type );
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorDeclaratorNode() );
				}
			}
		}

	public void checkType() {
		for ( int i = 0; i < size(); i++ ) {
			try {
				DeclaratorNode decltr = elementAt( i );
				decltr.checkType();
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorDeclaratorNode() );
				}
			}
		}

	public void eval( RunEnv runEnv ) {
		for ( int i = 0; i < size(); i++ ) {
			DeclaratorNode decltr = elementAt( i );
			decltr.eval( runEnv );
			}
		}

	}
