package node.declNode.declaratorNode;
import node.*;
import node.declNode.*;
import env.*;
import type.*;
import runEnv.*;
import text.*;

public abstract class DeclaratorNode extends Node implements DeclNode {

	protected String ident;
	public String ident() { return ident; }
	protected Type type;
	protected Decl decl;
	public Decl decl() { return decl; }

	public DeclaratorNode( String ident ) {
		this.ident = ident;
		}

	public DeclaratorNode() {
		}

	public void genEnv( int section, Env env ) {
		super.genEnv( env );
		decl = env.declare( ident, section, this );
		}

	public void setType( Type type ) {
		this.type = type;
		decl.setType( type );
		}

	public abstract void checkType();
	public abstract void eval( RunEnv runEnv );

	}
