package node.declNode.declaratorNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class InitDeclaratorNode extends DeclaratorNode {

	private ExprNode expr;

	public InitDeclaratorNode( String ident, ExprNode expr ) {
		super( ident );
		this.expr = expr;
		}

	public String toString() {
		return ident + " = " + expr;
		}

	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		expr.genEnv( env );
		}

	public void checkType() {
		Type exprType = expr.checkType();
		expr = expr.castTo( type );
		}

	public void eval( RunEnv runEnv ) {
		runEnv.getAddress( decl ).setValue( expr.eval( runEnv ) );
		}

	}
