package node.exprNode;
import node.*;
import node.exprNode.variableNode.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class AssignNode extends ExprNode {

	private VariableNode variable;
	private ExprNode expr;
	private Type varType;
	
	public AssignNode( VariableNode variable, ExprNode expr ) {
		this.variable = variable;
		this.expr = expr;
		precedence = 0;
		}
	
	public String toString() {
		return variable + " = " + expr;
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		variable.genEnv( env );
		expr.genEnv( env );
		}

	public Type checkType() {
		varType = variable.checkType();
		if ( ! variable.addressable() )
			error( "Operand for = not addressable" );
		Type exprType = expr.checkType();
		expr = expr.castTo( varType );
		type = VoidType.type;
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunAddress address = variable.evalAddress( runEnv );
		RunValue value = expr.eval( runEnv );
		address.setValue( value );
		return VoidValue.value;
		}
	}
