package node.exprNode.binaryNode.arithNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class ArithNode extends BinaryNode {

	public ArithNode( ExprNode left, ExprNode right ) {
		super( left, right );
		}

	public Type checkType() {
		Type leftType = left.checkType();
		Type rightType = right.checkType();
		type = Type.arithBalanceType( leftType, rightType );
		if ( type == null )
			error( "Incompatible operand types of " + leftType + 
				" and " + rightType + " for " + operator );
		left = left.castTo( type );
		right = right.castTo( type );
		return type;
		}

	}
