package node.exprNode.binaryNode.relationNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import java.util.*;

public class GreaterThanNode extends RelationNode {

	public GreaterThanNode( ExprNode left, ExprNode right ) {
		super( left, right );
		operator = ">";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		if ( operandType instanceof CharType )
			return new BoolValue( leftValue.charValue() > rightValue.charValue() );
		else if ( operandType instanceof IntType )
			return new BoolValue( leftValue.intValue() > rightValue.intValue() );
		else if ( operandType instanceof RealType )
			return new BoolValue( leftValue.realValue() > rightValue.realValue() );
		error( "Invalid Type for >" );
		return null;
		}

	}
