package node.exprNode.postfixNode;
import node.*;
import node.exprNode.*;
import node.exprNode.variableNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class PostDecNode extends PostfixVarNode {

	public PostDecNode( VariableNode left ) {
		super( left );
		this.left = left;
		operator = "--";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		left.genEnv( env );
		}

	public Type checkType() {
		Type leftType = left.checkType();
		if ( ! left.addressable() )
			error( "Operand for = not addressable" );
		if ( ! ( leftType instanceof IntType ) 
			&& ! ( leftType instanceof CharType ) )
			error( "Operand of -- operator must be an int or char" );
		type = leftType;
		return type;
		}
				
	public RunValue eval( RunEnv runEnv ) {
		RunAddress leftData = left.evalAddress( runEnv );
		RunValue leftValue = leftData.getValue();
		if ( type instanceof IntType )
			leftData.setValue( new IntValue( leftValue.intValue() - 1 ) );
		else
			leftData.setValue( new CharValue( ( char ) ( leftValue.charValue() - 1 ) ) );
		return leftValue;
		}

	}
