package node.exprNode.primaryNode;
import node.*;
import node.exprNode.*;
import node.typeNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class ArrayCreationNode extends PrimaryNode {

	private ExprNode sizeExpr;
	private TypeNode typeNode;

	public ArrayCreationNode( ExprNode sizeExpr, TypeNode typeNode ) {
		this.sizeExpr = sizeExpr;
		this.typeNode = typeNode;
		}

	public String toString() {
		return "new [ " + sizeExpr + " ]" + typeNode;
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		sizeExpr.genEnv( env );
		typeNode.genEnv( env );
		}

	public Type checkType() {
		Type sizeExprType = sizeExpr.checkType();
		Type subType = typeNode.getType();
		sizeExpr = sizeExpr.castTo( IntType.type );
		type = new ArrayType( subType );
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue size = sizeExpr.eval( runEnv );
		if ( type.equals( StringType.type ) )
			return new StringValue( new Multiple( size.intValue() ) );
		else
			return new ArrayValue( new Multiple( size.intValue() ) );
		}

	}
