package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public class FieldVariableNode extends VariableNode {

	private ExprNode structure;
	private String ident;
	private Decl fieldDecl;
	private Type sType;

	public FieldVariableNode( ExprNode structure, String ident ) {
		this.structure = structure;
		this.ident = ident;
		}

	public String toString() {
		return structure.toString( ExprNode.PREC_PRIMARY ) + "." + ident;
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		structure.genEnv( env );
		}
		
	public Type checkType() {
		sType = structure.checkType();
		ClassInstanceType structType = ( ClassInstanceType ) sType;
		fieldDecl = structType.env().searchLocal( ident );
		if ( fieldDecl == null )
			error( "Undeclared structure field " + ident );
		type = fieldDecl.type();
		return type;
		}

	public RunAddress evalAddress( RunEnv runEnv ) {
		RunValue instance = structure.eval( runEnv );
		if ( instance instanceof NullValue )
			error( "Selecting null value" );
		int offset = fieldDecl.offset();
		return instance.instanceValue().fields().getAddress( offset );
		}
	}
