package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;
import text.*;

public class IdentVariableNode extends VariableNode {

	private String ident;
	private Decl decl;
	
	public IdentVariableNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return ident;
		}

	public Type checkType() {
		decl = env().searchEnv( ident );
		if ( decl == null )
			error( "Undeclared identifier " + ident );
		switch ( decl.section() ) {
			case Decl.SECT_VARIABLE:
			case Decl.SECT_VARPARAM:
			case Decl.SECT_VALUEPARAM:
				type = decl.type();
				return type;
			default:
				error( "Invalid section" );
				return ErrorType.type;
			}
		}

	public RunAddress evalAddress( RunEnv runEnv ) {
		return runEnv.getAddress( decl );
		}

	}
