package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class CompoundStmtNode extends StmtNode {

	private DeclStmtListNode declStmtList;
	private Env localenv;

	public CompoundStmtNode( DeclStmtListNode declStmtList ) {
		this.declStmtList = declStmtList;
		}

	public String toString() {
		return "{%n" + declStmtList + "%n}";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		localenv = new Env( Env.ENV_LOCAL, env );
		declStmtList.genEnv( localenv );
		}

	public void setType() {
		declStmtList.setType();
		}

	public void checkType() {
		declStmtList.checkType();
		}
		
	public void eval( RunEnv runEnv ) throws UserException {
		Multiple locals = new Multiple( localenv.offset().value() );
		RunEnv localRunEnv = new RunEnv( locals, runEnv );
		declStmtList.eval( localRunEnv );
		}

	}
