package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class DoStmtNode extends StmtNode {

	private StmtNode stmt;
	private ExprNode cond;

	public DoStmtNode( StmtNode stmt, ExprNode cond ) {
		this.stmt = stmt;
		this.cond = cond;
		}

	public String toString() {
		return "do%+%n" + stmt + "%-%n%until ( " + cond + " );";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		stmt.genEnv( env );
		cond.genEnv( env );
		}

	public void setType() {
		stmt.setType();
		}

	public void checkType() {
		stmt.checkType();
		Type condType = cond.checkType();
		cond = cond.castTo( BoolType.type );
		}
		
	public void eval( RunEnv runEnv ) throws UserException {
		try {
			do
				try {
					stmt.eval( runEnv );
					}
				catch ( ContinueException exception ) {
					}
			while ( ! cond.eval( runEnv ).boolValue() );
			}
		catch ( BreakException exception ) {
			}
		}

	}
