package node.stmtNode;
import node.*;
import node.exprNode.*;
import node.declNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ExitStmtNode extends StmtNode {

	private String ident;
	private Decl decl;

	public ExitStmtNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return "exit " + ident + ";";
		}

	public void setType() {
		}

	public void checkType() {
		decl = env().searchEnv( ident );
		if ( decl == null )
			error( "Undeclared identifier " + ident );
		if ( decl.section() != Decl.SECT_LABEL )
			error( "Identifier " + ident + " not label" );
		}
		
	public void eval( RunEnv runEnv ) throws ExitException {
		throw new ExitException( decl );
		}

	}
