package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class IfStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode thenPart;

	public IfStmtNode( ExprNode cond, StmtNode thenPart ) {
		this.cond = cond;
		this.thenPart = thenPart;
		}

	public String toString() {
		return "if ( " + cond + " )%+%n" + thenPart + "%-";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		cond.genEnv( env );
		thenPart.genEnv( env );
		}

	public void setType() {
		thenPart.setType();
		}

	public void checkType() {
		Type condType = cond.checkType();
		cond = cond.castTo( BoolType.type );
		thenPart.checkType();
		}
		
	public void eval( RunEnv runEnv ) throws UserException {
		if ( cond.eval( runEnv ).boolValue() )
			thenPart.eval( runEnv );
		}

	}
