package node.typeNode;
import node.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ArrayTypeNode extends TypeNode {

	private TypeNode subTypeNode;

	public ArrayTypeNode( TypeNode subTypeNode ) {
		this.subTypeNode = subTypeNode;
		}

	public String toString() {
		return "[]" + subTypeNode;
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		subTypeNode.genEnv( env );
		}

	public Type getType() {
		Type subType = subTypeNode.getType();
		if ( subType instanceof CharType )
			return new StringType();
		else
			return new ArrayType( subType );
		}
		
	}
