package node.typeNode;
import env.*;
import type.*;
import runEnv.*;
import text.*;

public class TypeIdentNode extends TypeNode {

	private String ident;
	
	public TypeIdentNode( String ident ) {
		this.ident = ident;
		}

	public Type getType() {
		Decl decl = env().searchEnv( ident );
		if ( decl == null )
			error( "Undeclared Type " + ident );
		if ( decl.section() != Decl.SECT_CLASS )
			error( "Identifier " + ident + " not declared as type" );
		Type type = decl.type().instanceType();
		return type;
		}

	public String toString() {
		return ident;
		}
	}
