package runEnv;

public class ArrayValue extends RunValue {

	private Multiple base;
	private int offset, size;
	
	public Multiple base() { return base; }
	public int offset() { return offset; }
	public int size() { return size; }

	public ArrayValue( Multiple base, int offset, int size ) {
		if ( offset + size > base.size() )
			throw new Error( "subarray out of bounds" );
		this.base = base;
		this.offset = offset;
		this.size = size;
		}

	public ArrayValue( Multiple base ) {
		this.base = base;
		this.offset = 0;
		this.size = base.size();
		}

	public String toString() {
		String result = "";
		if ( size() == 0 )
			return "{}";
		for ( int i = 0; i < size(); i++ ) {
			if ( i > 0 )
				result += ", ";
			result += getValue( i );
			}
		return "{ " + result + " }";
		}

	public RunValue getValue( int i ) {
		return ( RunValue ) base.getValue( offset + i );
		}

	public RunAddress getAddress( int i ) {
		return new RunAddress( base, offset + i );
		}

	public void setValue( int i, RunValue value ) {
		base.setValue( offset + i, value );
		}

	public ArrayValue arrayValue() {
		return this;
		}

	public ArrayValue subArray( int offset, int size ) {
		if ( offset + size > this.size )
			throw new Error( "subarray out of bounds" );
		return new ArrayValue( base, this.offset + offset, size );
		}
	}
