package type;

import node.*;
import env.*;

public  class MethodType extends Type {

	private String ident;
	private Type returnType;
	private DeclList formalDecls;
	public String ident() { return ident; }
	public Type returnType() { return returnType; }
	public DeclList formalDecls() { return formalDecls; }

	public MethodType( String ident, Type returnType, DeclList formalDecls ) {
		this.ident = ident;
		this.returnType = returnType;
		this.formalDecls = formalDecls;
		}
	
	public boolean equals( Type type ) {
		if ( type == this )
			return true;
		if ( ! ( type instanceof MethodType ) )
			return false;
		MethodType methodType = ( MethodType ) type;
		return methodType.ident().equals( ident );
		}

	public String toString() {
		return returnType() + " " + ident + "(%+" + formalDecls() + " %-)";
		}
	}
