package type;

import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public abstract class Type {

	public static Type arithBalanceType( Type type1, Type type2 ) {
		if ( CharType.type.isCastable( type1 ) 
			&& CharType.type.isCastable( type2 ) )
			return CharType.type;
		else if ( IntType.type.isCastable( type1 ) 
			&& IntType.type.isCastable( type2 ) )
			return IntType.type;
		else if ( RealType.type.isCastable( type1 ) 
			&& RealType.type.isCastable( type2 ) )
			return RealType.type;
		return null;
		}
		
	public static Type balanceType( Type type1, Type type2 ) {
		if ( type1.isCastable( type2 ) )
			return type1;
		if ( type2.isCastable( type1 ) )
			return type2;
		else
			return null;
		}
		
	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return this == type;
		}
		
	public abstract String toString();

	public boolean isCastable( Type type ) {
		return equals( type );
		}

	public RunValue defaultValue() {
		return NullValue.value;
		}

	public Type instanceType() {
		throw new Error( "type " + this + " not a class type" );
		}

	}
