package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class RealType extends BasicType {

	public final static RealType type = new RealType();

	public RealType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return type instanceof RealType;
		}

	public boolean isCastable( Type type ) {
		return type instanceof RealType || type instanceof IntType;
		}

	public String toString() {
		return "real";
		}
		
	public RunValue defaultValue() {
		return new RealValue( 0.0 );
		}

	}
