package node.declNode;
import node.*;
import node.typeNode.*;
import node.declNode.declaratorNode.*;
import env.*;
import type.*;
import runEnv.*;

public class LocalDeclNode extends DeclStmtNode implements DeclNode {

	private TypeNode typeNode;
	private DeclaratorListNode declrList;

	private Type type;

	public LocalDeclNode( TypeNode typeNode, DeclaratorListNode declrList ) {
		this.typeNode = typeNode;
		this.declrList = declrList;
		}

	public String toString() {
		return typeNode + " " + declrList + ";";
		}

	public void genEnv( int section, Env localEnv ) {
		typeNode.genEnv( localEnv );
		declrList.genEnv( section, localEnv );
		}

	public void genDecl() {
		type = typeNode.getType();
		declrList.genDecl( type );
		}

	public void checkType() {
		declrList.checkType();
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		declrList.eval( runEnv );
		}

	public int calcWeight() {
		weight = declrList.calcWeight();
		return weight;
		}

	public void genDeclCode() {
		declrList.genDeclCode();
		}

	public void genCode() {
		enter();
		declrList.genCode();
		exit();
		}

	}
