package node.declNode.declaratorNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class InitDeclaratorNode extends DeclaratorNode {

	private ExprNode expr;

	public InitDeclaratorNode( String ident, ExprNode expr ) {
		super( ident );
		this.expr = expr;
		}

	public String toString() {
		return ident + " = " + expr;
		}

	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		expr.genEnv( env );
		}

	public void checkType() {
		Type exprType = expr.checkType();
		expr = expr.castTo( type );
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		runEnv.getData( decl ).setValue( expr.eval( runEnv ) );
		}

	public int calcWeight() {
		weight = expr.calcWeight();
		return weight;
		}

	public void genCode() {
		expr.regCode( 0, 0 );
		if ( type instanceof RealType )
			decl.storeF( ftempReg( 0 ) );
		else
			decl.store( tempReg( 0 ) );
		}

	}
