package node.exprNode.binaryNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class BinaryNode extends ExprNode {

	protected String operator;
	protected String opCode;
	protected Type operandType;
	protected ExprNode left, right;

	public BinaryNode( ExprNode left, ExprNode right ) {
		this.left = left;
		this.right = right;
		}
		
	public String toString() {
		return 
			left.toString( precedence ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	public void genEnv( Env env ) {
		left.genEnv( env );
		right.genEnv( env );
		}

	public int calcWeight() {
		int leftWeight = left.calcWeight();
		int rightWeight = right.calcWeight();
		weight = min( 
			max( leftWeight + 1, rightWeight ),
			max( rightWeight + 1, leftWeight ) );
		return weight;
		}

	}
