package node.exprNode.binaryNode.arithNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class TimesNode extends ArithNode {

	public TimesNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_MUL;
		operator = "*";
		}

	public Type checkType() {
		type = super.checkType();
		if ( type instanceof IntType )
			opCode = "mulq";
		else if ( type instanceof RealType )
			opCode = "mult";
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		if ( type instanceof IntType )
			return new IntValue( leftValue.intValue() * rightValue.intValue() );
		else if ( type instanceof RealType )
			return new RealValue( leftValue.realValue() * rightValue.realValue() );
		error( "Invalid Type for *" );
		return null;
		}
	}
