package node.exprNode.binaryNode.boolNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class AndNode extends BoolNode {

	public AndNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_AND;
		operator = "and";
		opCode = "and";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new BoolValue( leftValue.boolValue() && rightValue.boolValue() );
		}

	public void boolCode( 
		int freeReg, 
		int freeTemp, 
		String trueLabel, 
		String falseLabel, 
		boolean flowIntoTrue ) {
		String secondPart = Label.newLabel();
		enter();
		left.boolCode( freeReg, freeTemp, secondPart, falseLabel, true );
		labelDefn( secondPart );
		right.boolCode( freeReg, freeTemp, trueLabel, falseLabel, flowIntoTrue );
		exit();
		}

	}
