package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class PrefixNode extends ExprNode {

	protected String operator;
	protected String opCode;
	protected Type operandType;
	protected ExprNode right;

	public PrefixNode( ExprNode right ) {
		this.right = right;
		precedence = PREC_PREFIX;
		}
		
	public String toString() {
		return operator + " " + right.toString( precedence );
		}

	public void genEnv( Env env ) {
		right.genEnv( env );
		}

	public int calcWeight() {
		int rightWeight = right.calcWeight();
		weight = rightWeight;
		return weight;
		}

	public void regCode( int freeReg, int freeTemp ) {
		right.regCode( freeReg, freeTemp );
		if ( operandType instanceof RealType ) {
			instrn( opCode, ftempReg( freeReg ), ftempReg( freeReg ) );
			}
		else {
			instrn( opCode, tempReg( freeReg ), tempReg( freeReg ) );
			}
		}
	}
