package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import text.*;
import runEnv.*;
import runEnv.basicValue.*;

public class StringValueNode extends ValueNode {

	private String value;

	public StringValueNode( String value ) {
		this.value = value;
		}

	public String toString() {
		return "\"" + Convert.toString( value ) + "\"";
		}

	public Type checkType() {
		type = StringType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new StringValue( value );
		}

	public int calcWeight() {
		weight = MAXREG;
		return weight;
		}

	public void regCode( int freeReg, int freeTemp ) {
		enter();
		enter( "const" );
		align();
		labelDefn( "string" );
		asciiz( value );
		exit();
		loadIQ( "$a0", "string" );
		bsr( "Array.fromString.enter" );
		move( "$v0", tempReg( freeReg ) );
		exit();
		}
	}
