package type;

import template.*;
import type.basicType.*;

public  class ArrayType extends FieldType {

	private Type subType;
	public Type subType() { return subType; }
	
	public ArrayType( Type subType ) {
		this.subType = subType;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof ArrayType ) )
			return false;
		ArrayType otherType = ( ArrayType ) type;
		return subType().equals( otherType.subType() );
		}

	public boolean isCastable( Type type ) {
		return equals( type ) || type instanceof NullType;
		}

	public String toString() {
		return "[]" + subType;
		}
		
	}
