package type;

import env.*;
import template.*;

public  class ClassType extends FieldType {

	private String ident;
	private Env env;
	public String ident() { return ident; }
	public Env env() { return env; }

	public Template template() { return ClassTemplate.template; }

	public ClassType( String ident, Env env ) {
		this.ident = ident;
		this.env = env;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof ClassType ) )
			return false;
		ClassType classType = ( ClassType ) type;
		return classType.ident().equals( ident );
		}

	public boolean isCastable( Type type ) {
		return false;
		}

	public String toString() {
		return "class " + ident;
		}

	public InstanceType instanceType() {
		return new InstanceType( ident, env );
		}

	}
