package type;

import node.*;
import env.*;
import template.*;

public  class MethodType extends Type {

	private Type returnType;
	private DeclList formalDecls;
	public Type returnType() { return returnType; }
	public DeclList formalDecls() { return formalDecls; }

	public Template template() {
		return new InvocationTemplate( formalDecls.typeList() );
		}

	public MethodType( Type returnType, DeclList formalDecls ) {
		this.returnType = returnType;
		this.formalDecls = formalDecls;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof MethodType ) )
			return false;
		MethodType methodType = ( MethodType ) type;
		if ( ! returnType().equals( methodType.returnType() ) )
			return false;
		DeclList formals = formalDecls();
		DeclList methodFormals = methodType.formalDecls();
		if ( formals.size() != methodFormals.size() )
			return false;
		for ( int i = 0; i < formals.size(); i++ ) {
			Decl decl1 = formals.elementAt( i );
			Decl decl2 = methodFormals.elementAt( i );
			if ( ! decl1.type().equals( decl2.type() ) )
				return false;
			if ( decl1.section() != decl2.section() )
				return false;
			}
		return true;
		}

	public String toString() {
		return returnType() + "(%+" + formalDecls() + " %-)";
		}
	}
