package type;

import type.basicType.*;
import template.*;
import runEnv.*;
import runEnv.basicValue.*;

public abstract class Type {

	public static Type balanceType( Type type1, Type type2 ) {
		if ( IntType.type.isCastable( type1 ) && IntType.type.isCastable( type2 ) )
			return IntType.type;
		else if ( RealType.type.isCastable( type1 ) && RealType.type.isCastable( type2 ) )
			return RealType.type;
		return null;
		}
		
	public abstract boolean equals( Type type );
	public abstract String toString();
	public abstract Template template();

	public InstanceType instanceType() {
		throw new Error( "Can only invoke instanceType for classType" );
		}

	public boolean isCastable( Type type ) {
		return equals( type );
		}

	public RunValue defaultValue() {
		return new NullValue();
		}
	}
