package grammar;

import java.io.*;

%%

%{
	boolean printed = false;
	
	void echo( String text ) {
		System.out.print( text );
		printed = true;
		}
%}

%init{
	yybegin( NORMAL );
%init}

%public
%type Void

%state NORMAL COMMENT CODESTRING

newline		=	\r|\n|\r\n
%%
<NORMAL> {
	"/*"			{ yybegin( COMMENT ); }
	"{:"			{ yybegin( CODESTRING ); }
	{newline}		{
					if ( printed ) {
						System.out.println();
						printed = false;
						}
					}
	:[A-Za-z0-9]+	{ }
	.				{ echo( yytext() ); }
	}
	
<COMMENT> {
	"*/"			{ yybegin( NORMAL ); }
	{newline}		{ }
	.				{ }
	}
	
<CODESTRING> {
	":}"			{ yybegin( NORMAL ); }
	{newline}		{ }
	.				{ }
	}
