import grammar.*;
import java.io.*;

public class Main {

	public static void main( String[] argv ) {
		String dirName = null;

		try {
			for ( int i = 0; i < argv.length; i++ ) {
				if ( argv[ i ].equals( "-dir" ) ) {
					i++;
					if ( i >= argv.length )
						throw new Error( "Missing directory name" );
					dirName = argv[ i ];
					}
				else {
					throw new Error( 
						"Usage: java Main -dir directory" );
					}
				}

			if ( dirName == null )
				throw new Error( "Directory not specified" );

			FileInputStream fileInputStream = new FileInputStream( 
				new File( dirName, "program.in" ) );
			System.setErr( new PrintStream( new FileOutputStream( 
				new File( dirName, "program.err" ) ) ) );
			System.setOut( new PrintStream( new FileOutputStream( 
				new File( dirName, "program.out" ) ) ) );

			Yylex lexer = new Yylex( fileInputStream );
			lexer.yylex();
			}
		catch ( Exception exception ) {
			System.err.println( "Exception in Main " + exception.toString() );
			exception.printStackTrace();
			}
		}
	}

